var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/http/response-handler.ts
var response_handler_exports = {};
__export(response_handler_exports, {
  default: () => response_handler_default
});
module.exports = __toCommonJS(response_handler_exports);

// src/http/responses.ts
var HttpResponse = class {
  constructor(body, options = {}) {
    this.body = body;
    this.isHttpResponse = true;
    this.stream = false;
    this.headers = {};
    this.stream = options.stream || false;
  }
  setHeader(name, value) {
    this.headers[name] = value;
    return this;
  }
  getHeader(name) {
    return this.headers[name];
  }
  getHeaders() {
    return __spreadValues({}, this.headers);
  }
};
var HttpResponseSuccess = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseSuccess = true;
  }
};
var HttpResponseOK = class extends HttpResponseSuccess {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseOK = true;
    this.statusCode = 200;
    this.statusMessage = "OK";
  }
};

// src/http/response-sender.ts
var responseSender = (response, result) => {
  response.status(result.statusCode);
  response.set(result.getHeaders());
  if (typeof result.body === "number") {
    result.body = result.body.toString();
  }
  response.send(result.body);
};
var response_sender_default = responseSender;

// src/http/response-handler.ts
var responseHandler = (fn) => function asyncUtilWrap(request, response, next) {
  const fnReturn = fn(request, response, next);
  Promise.resolve(fnReturn).then((result) => {
    if (result instanceof HttpResponse) {
      response_sender_default(response, result);
    } else {
      response_sender_default(response, new HttpResponseOK(result));
    }
  }).catch(next);
};
var response_handler_default = responseHandler;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
