var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/jwt.ts
var jwt_exports = {};
__export(jwt_exports, {
  authWithJWT: () => authWithJWT
});
module.exports = __toCommonJS(jwt_exports);
var import_permit = require("permit");
var import_jsonwebtoken = require("jsonwebtoken");

// src/api.ts
var import_hypernight2 = require("@hyperstackjs/hypernight");
var import_async_express_mw = __toESM(require("async-express-mw"));
var import_lodash = __toESM(require("lodash"));

// src/http/responses.ts
var HttpResponse = class {
  constructor(body, options = {}) {
    this.body = body;
    this.isHttpResponse = true;
    this.stream = false;
    this.headers = {};
    this.stream = options.stream || false;
  }
  setHeader(name, value) {
    this.headers[name] = value;
    return this;
  }
  getHeader(name) {
    return this.headers[name];
  }
  getHeaders() {
    return __spreadValues({}, this.headers);
  }
};
var HttpResponseClientError = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseClientError = true;
  }
};
var HttpResponseUnauthorized = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseUnauthorized = true;
    this.statusCode = 401;
    this.statusMessage = "UNAUTHORIZED";
    this.setHeader("WWW-Authenticate", "");
  }
};

// src/server/hyperserver.ts
var import_helmet = __toESM(require("helmet"));
var import_compression = __toESM(require("compression"));
var import_hypernight = require("@hyperstackjs/hypernight");
var import_body_parser = require("body-parser");
var import_express_pino_logger = __toESM(require("express-pino-logger"));
var import_pino = __toESM(require("pino"));
var import_debug2 = __toESM(require("debug"));

// src/server/index-sender.ts
var import_path = __toESM(require("path"));
var import_fs = __toESM(require("fs"));

// src/server/set-request-id.ts
var import_uuid = require("uuid");

// src/server/error-handler.ts
var import_debug = __toESM(require("debug"));
var debug = (0, import_debug.default)("hypercontroller:error-handler");

// src/server/hyperserver.ts
var debug2 = (0, import_debug2.default)("hyperserver");

// src/server/list-routes.ts
var import_path2 = __toESM(require("path"));

// src/server/print-routes.ts
var import_colorette = require("colorette");

// src/server/load.ts
var import_path3 = __toESM(require("path"));
var import_glob = __toESM(require("glob"));

// src/api.ts
var import_hypernight3 = require("@hyperstackjs/hypernight");
var Middleware = (mware) => (0, import_hypernight2.Middleware)(import_lodash.default.castArray(mware).map((m) => (0, import_async_express_mw.default)(m)));
var ClassMiddleware = (mware) => (0, import_hypernight2.ClassMiddleware)(import_lodash.default.castArray(mware).map((m) => (0, import_async_express_mw.default)(m)));

// src/jwt.ts
var forceHS512 = (jwtOptions) => jwtOptions ? __spreadProps(__spreadValues({}, jwtOptions), { algorithm: "HS512" }) : { algorithm: "HS512" };
var forceHS512Verify = (jwtOptions) => jwtOptions ? __spreadProps(__spreadValues({}, jwtOptions), { algorithms: ["HS512"] }) : { algorithms: ["HS512"] };
var createAuth = (verify2, { loader, bearer }) => {
  const permit = new import_permit.Bearer(bearer || {
    query: "access_token"
  });
  return async (req) => {
    const token = permit.check(req);
    if (!token) {
      throw new HttpResponseUnauthorized("no token");
    }
    let payload;
    try {
      payload = await verify2(token);
    } catch (error) {
      throw new HttpResponseUnauthorized("bad token");
    }
    const detail = await loader(payload);
    if (!detail || !detail.user) {
      throw new HttpResponseUnauthorized("no such user");
    }
    return detail;
  };
};
var buildAuth = (verify2, MWare, opts) => {
  const auth = createAuth(verify2, opts);
  return MWare(async (req, res, next) => {
    const _a = await auth(req), { user } = _a, rest = __objRest(_a, ["user"]);
    req.user = user;
    req.state = rest;
    next();
  });
};
var authWithJWT = ({
  secret,
  jwtOptions,
  loader,
  bearer
}) => {
  if (!secret) {
    throw new Error("no JWT secret set");
  }
  const resolvedOptions = jwtOptions || {
    expiresIn: "14d"
  };
  const signJWT = (payload) => (0, import_jsonwebtoken.sign)(payload, secret, forceHS512(resolvedOptions));
  const verifyJWT = (token) => new Promise((resolve, reject) => {
    (0, import_jsonwebtoken.verify)(token, secret, forceHS512Verify(resolvedOptions), (err, value) => {
      if (err) {
        reject(err);
      } else {
        resolve(value);
      }
    });
  });
  return {
    MustAuthWithJWT: buildAuth(verifyJWT, ClassMiddleware, { loader, bearer }),
    MustAuthRouteWithJWT: buildAuth(verifyJWT, Middleware, { loader, bearer }),
    signJWT,
    verifyJWT
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  authWithJWT
});
