var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/server/error-handler.ts
var error_handler_exports = {};
__export(error_handler_exports, {
  default: () => error_handler_default
});
module.exports = __toCommonJS(error_handler_exports);
var import_debug = __toESM(require("debug"));

// src/http/responses.ts
var HttpResponse = class {
  constructor(body, options = {}) {
    this.body = body;
    this.isHttpResponse = true;
    this.stream = false;
    this.headers = {};
    this.stream = options.stream || false;
  }
  setHeader(name, value) {
    this.headers[name] = value;
    return this;
  }
  getHeader(name) {
    return this.headers[name];
  }
  getHeaders() {
    return __spreadValues({}, this.headers);
  }
};
var HttpResponseClientError = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseClientError = true;
  }
};
var HttpResponseBadRequest = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseBadRequest = true;
    this.statusCode = 400;
    this.statusMessage = "BAD REQUEST";
  }
};

// src/http/response-sender.ts
var responseSender = (response, result) => {
  response.status(result.statusCode);
  response.set(result.getHeaders());
  if (typeof result.body === "number") {
    result.body = result.body.toString();
  }
  response.send(result.body);
};
var response_sender_default = responseSender;

// src/server/error-handler.ts
var debug = (0, import_debug.default)("hypercontroller:error-handler");
var errorHandler = ({
  logger,
  sendValidationErrors = false
}) => async (err, req, res, next) => {
  debug("error %o", err);
  debug("sending validation errors out? %o", sendValidationErrors);
  if (err instanceof HttpResponse) {
    response_sender_default(res, err);
  } else if (err.isValidationError && sendValidationErrors) {
    response_sender_default(res, new HttpResponseBadRequest({
      error: "validation",
      validationErrors: err.errors
    }));
  } else if (err.isModelError) {
    response_sender_default(res, new HttpResponseBadRequest({ error: err.message }));
  } else if (err) {
    const resolvedLogger = req && req.logger ? req.logger : logger;
    if (resolvedLogger) {
      resolvedLogger.error({ err }, `Internal error`);
    }
    response_sender_default(res, new HttpResponseBadRequest({ error: "bad request" }));
  } else {
    next();
  }
};
var error_handler_default = errorHandler;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
