var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/server/list-routes.ts
var list_routes_exports = {};
__export(list_routes_exports, {
  default: () => list_routes_default
});
module.exports = __toCommonJS(list_routes_exports);
var import_path = __toESM(require("path"));
function getPathFromRegex(regexp) {
  return regexp.toString().replace("/^", "").replace("?(?=\\/|$)/i", "").replace(/\\\//g, "/");
}
function combineStacks(acc, stack) {
  if (stack.handle.stack) {
    const routerPath = getPathFromRegex(stack.regexp);
    return [
      ...acc,
      ...stack.handle.stack.map((stack2) => __spreadValues({ routerPath }, stack2))
    ];
  }
  return [...acc, stack];
}
function getStacks(app) {
  if (app.routes) {
    return Object.keys(app.routes).reduce((acc, method) => [...acc, ...app.routes[method]], []).map((route) => ({ route: { stack: [route] } }));
  }
  if (app._router && app._router.stack) {
    return app._router.stack.reduce(combineStacks, []);
  }
  if (app.stack) {
    return app.stack.reduce(combineStacks, []);
  }
  if (app.router && app.router.stack) {
    return app.router.stack.reduce(combineStacks, []);
  }
  return [];
}
function listRoutes(app) {
  const stacks = getStacks(app);
  const routes = [];
  if (stacks) {
    for (const stack of stacks) {
      if (stack.route) {
        const routeLogged = {};
        for (const route of stack.route.stack) {
          const method = route.method ? route.method.toUpperCase() : null;
          if (!routeLogged[method] && method) {
            const stackPath = stack.routerPath || route.path ? import_path.default.resolve([stack.routerPath, stack.route.path, route.path].filter((s) => !!s).join("")) : stack.route.path;
            routes.push({ verb: method, path: stackPath });
            routeLogged[method] = true;
          }
        }
      }
    }
  }
  return routes;
}
var list_routes_default = listRoutes;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
